import java.util.*;
import java.lang.*;
import java.io.*;

public class circle
{
    private double x,y,z,r;
    private final double PI=java.lang.Math.PI;
    private ArrayList lines;
    private boolean rotate;

    public circle()
    {
	x=0;
	y=0;
	z=0;
	r=100;
	lines=new ArrayList();
	rotate=false;
    }

    public circle(double r)
    {
	this.r=r;
	x=0;
	y=0;
	z=0;
	lines=new ArrayList();
	rotate=false;
    }

    public circle(double x, double y, double z, double r)
    {
	this.x=x;
	this.y=y;
	this.z=z;
	this.r=r;
	lines=new ArrayList();
	rotate=false;
    }

    public ArrayList drawCircle()
    {
	ArrayList a=new ArrayList();
	double x1,y1,z1, xtemp, ytemp, ztemp;
	x1=0;y1=0;z1=0;
	xtemp=0;ytemp=0;ztemp=0;
	for(double d=0; d<=2*PI; d+=0.1){
	    if(d!=0){
		matrix m=new matrix();
		m.makeLine(x1,y1,z1,r*cos(d)+x, r*sin(d)+y,0);
		m.setRotate(rotate);
		a.add((Object)m);
	    }
	    else{
		xtemp=r*cos(d)+x;
		ytemp=r*sin(d)+y;
	    }
	   
	    x1=r*cos(d)+x;
	    y1=r*sin(d)+y;
	}
	matrix m=new matrix();
	m.makeLine(xtemp,ytemp,ztemp,x1,y1,z1);
	m.setRotate(rotate);
	a.add((Object)m);
	lines=a;
	return a;
    }

    public point[] drawCir()
    {
	int in=15;
	point[] points=new point[360/in];
	for(double d=0;d<360; d+=in)
	    points[(int) d/in]=new point(r*cos(d*PI/180)+x,r*sin(d*PI/180)+y,z);
	return points;
    }

    private double cos(double d)
    {return java.lang.Math.cos(d);}

    private double sin(double d)
    {return java.lang.Math.sin(d);}

    public void setR(double d)
    {r=d;}
    public void setX(double d)
    {x=d;}
    public void setY(double d)
    {y=d;}
    public void setZ(double d)
    {z=d;}
    public void setRotate(boolean b)
    {rotate=b;}

    public double getX()
    {return x;}
    public double getY()
    {return y;}
    public double getZ()
    {return z;}
    public double getR()
    {return r;}
    public ArrayList getLines()
    {return lines;}
    public boolean getRotate()
    {return rotate;}

    public String toString()
    {
	return "Center: ("+x+", "+y+", "+z+")\tRadius: "+r;
    }
}

class sphere
{
    private double x,y,z,r;
    private boolean rotate;
    private ArrayList polygons;
    
    public sphere()
    {
	x=0;
	y=0;
	z=0;
	r=10;
	rotate=false;
	polygons=new ArrayList();
    }

    public sphere(double r)
    {
	this.r=r;
	x=0;
	y=0;
	z=0;
	rotate=false;
	polygons=new ArrayList();
    }

    public sphere(double x, double y,double z, double r)
    {
	this.r=r;
	this.x=x;
	this.y=y;
	this.z=z;
	rotate=false;
	polygons=new ArrayList();
    }

    public ArrayList drawSphere()
    {
	ArrayList result=new ArrayList();
	double xcor,ycor,zcor;
	int in=15;
	point [][]points=new point[360/in][360/in];

	for(double d=0; d<360; d+=in)
	    for(double d2=0; d2<360; d2+=in){
		xcor=r*(cos(d2))*cos(d)+x;
		ycor=r*(sin(d2))+y;
		zcor=(-r)*cos(d2)*sin(d)+z;
		points[(int)d/in][(int) d2/in]=new point(xcor,ycor,zcor);
	    }
	
	for(int i=0; i<points.length; i++)
	    for(int j=0; j<points[0].length; j++){
		matrix m=new matrix();
		matrix m2=new matrix();
		matrix[] quad=new matrix[4];
		
		m.makeLine(points[i][(j+1)%points[0].length],points[i][j]);
		m.setRotate(rotate);
		result.add((Object)m);
		quad[0]=m;
		m2.makeLine(points[i][j],points[(i+1)%points.length][j]);
		m2.setRotate(rotate);
		result.add((Object) m2);
		quad[1]=m2;
		quad[2]=new matrix(points[(i+1)%points.length][j],points[(i+1)%points.length][(j+1)%points[0].length]);
		quad[3]=new matrix(points[(i+1)%points.length][(j+1)%points[0].length],points[i][(j+1)%points[0].length]);
		quad q=new quad(quad);
		polygons.add(q);
		//		System.out.println(q);
	    }
	return result;
    }

    private double sin(double d)
    {return java.lang.Math.sin(d*(java.lang.Math.PI/180));}
   
    private double cos(double d)
    {return java.lang.Math.cos(d*(java.lang.Math.PI/180));}

    public void setX(double x)
    {this.x=x;}
    public void setY(double y)
    {this.y=y;}
    public void setZ(double z)
    {this.z=z;}
    public void setR(double r)
    {this.r=r;}
    public void setRotate(boolean b)
    {rotate=b;}

    public double getX()
    {return x;}
    public double getY()
    {return y;}
    public double getZ()
    {return z;}
    public double getR()
    {return r;}
    public boolean getRotate()
    {return rotate;}
    public ArrayList getPolygons()
    {return polygons;}

    public String toString()
    {
	return "Center: ("+x+", "+y+", "+z+")\tRadius: "+r;
    }
}

class torus
{
    private double x,y,z,r1,r2;
    private ArrayList polygons;
    private boolean rotate;

    public torus()
    {
	x=300;
	y=300;
	z=0;
	r1=50;
	r2=30;
	polygons=new ArrayList();
	rotate=false;
    }

    public torus(double r1, double r2)
    {
	this.r1=r1;
	this.r2=r2;
	x=300;
	y=300;
	z=0;
	polygons=new ArrayList();
	rotate=false;
    }

    public torus(double x,double y, double z, double r1, double r2)
    {
	this.x=x;
	this.y=y;
	this.z=z;
	this.r1=r1;
	this.r2=r2;
	polygons=new ArrayList();
	rotate=false;
    }

    private double xtorus(double d1, double d2)
    {return (r2+r1*cos(d1))*cos(d2);}

    private double ytorus(double d1, double d2)
    {return (r2+r1*cos(d1))*sin(d2);}

    private double ztorus(double d1)
    {return r1*sin(d1);}

    private double sin(double d)
    {return java.lang.Math.sin(d*(java.lang.Math.PI/180));}
   
    private double cos(double d)
    {return java.lang.Math.cos(d*(java.lang.Math.PI/180));}
    
    public ArrayList drawTorus()
    {
	ArrayList result=new ArrayList();
	int in=15;
	point[][] points=new point[360/in][360/in];

	for(double d1=0; d1<360; d1+=in)
	    for(double d2=0; d2<360; d2+=in){
		point p=new point((r1+r2*cos(d1))*cos(d2)+x, (r1+r2*cos(d1))*sin(d2)+y,r2*sin(d1)+z);
		points[(int) d1/in][(int) d2/in]=p;
	    }
	
	for(int i=0;i<points.length; i++)
	    for(int j=0; j<points[0].length; j++){
		matrix[] quad=new matrix[4];
		matrix m=new matrix();
		matrix m2=new matrix();

		m.makeLine(points[i][(j+1)%points[0].length],points[i][j]);
		m.setRotate(rotate);
		quad[0]=m;
		result.add((Object) m);
		m2.makeLine(points[i][j], points[(i+1)%points.length][j]);
		m2.setRotate(rotate);
		quad[1]=m2;
		result.add((Object) m2);
		quad[2]=new matrix(points[(i+1)%points.length][j],points[(i+1)%points.length][(j+1)%points[0].length]);
                quad[3]=new matrix(points[(i+1)%points.length][(j+1)%points[0].length],points[i][(j+1)%points[0].length]);
                quad q=new quad(quad);
                polygons.add(q);
		//		System.out.println(q);
	    }	
	return result;
    }

    public void setX(double x)
    {this.x=x;}
    public void setY(double y)
    {this.y=y;}
    public void setZ(double z)
    {this.z=z;}
    public void setR1(double r1)
    {this.r1=r1;}
    public void setR2(double r2)
    {this.r2=r2;}
    public void setRotate(boolean b)
    {rotate=b;}

    public double getX()
    {return x;}
    public double getY()
    {return y;}
    public double getZ()
    {return z;}
    public double getR1()
    {return r1;}
    public double getR2()
    {return r2;}
    public boolean getRotate()
    {return rotate;}
    public ArrayList getPolygons()
    {return polygons;}

    public String toString()
    {
	return "Center: ("+x+", "+y+", "+z+")\tRadius: R1  "+r1+ " R2 "+r2;
    }
}
