import java.util.*;

public class cone
{
    private double x,y,z,r,h;

    public cone()
    {
	x=300;
	y=300;
	z=0;
	r=100;
	h=50;
    }

    public cone(double x, double y, double z)
    {
	this.x=x;
	this.y=y;
	this.z=z;
	r=100;
	h=50;
    }

    public cone(double x, double y, double z, double r, double h)
    {
	this.x=x;
	this.y=y;
	this.z=z;
	this.r=r;
	this.h=h;
    }

    private double cos(double d)
    {return java.lang.Math.cos(d*(java.lang.Math.PI/180));}
    private double sin(double d)
    {return java.lang.Math.sin(d*(java.lang.Math.PI/180));}

    private double x(double d,int i)
    {return ((h-i)/h)*r*cos(d)+x;}
    private double y(double d,int i)
    {return ((h-i)/h)*r*sin(d)+y;}

    public ArrayList drawCone()
    {
	ArrayList result=new ArrayList();
	int in=15;
	point[][] points=new point[(int) h][360/in];

	for(int i=0; i<h; i++)
	    for(double d=0; d<360; d+=in)
		points[i][(int) d/in]=new point(x(d,i), y(d,i),i+z);

	for(int i=0; i<points.length; i++)
	    for(int j=0; j<points[0].length; j++){
		matrix m1=new matrix();
		matrix m2=new matrix();

		m1.makeLine(points[i][j], points[i][(j+1)%points[0].length]);
		m2.makeLine(points[i][j],points[(i+1)%points.length][j]);

		result.add(m1);
		result.add(m2);
	    }
	return result;
    }
    
    public void setX(double x)
    {this.x=x;}
    public void setY(double y)
    {this.y=y;}
    public void setZ(double z)
    {this.z=z;}
    public void setR(double r)
    {this.r=r;}
    public void setH(double h)
    {this.h=h;}

    public double getX()
    {return x;}
    public double getY()
    {return y;}
    public double getZ()
    {return z;}
    public double getR()
    {return r;}
    public double getH()
    {return h;}

    public String toString()
    {
	return "Center: ("+x+", "+y+", "+z+")\tRadius: "+r+"\tHeight: "+h;
    }
}

class cylinder
{
    double x,y,z,r,h;

    public cylinder()
    {
	x=0;
	y=0;
	z=0;
	r=100;
	h=100;
    }

    public cylinder(double r, double h)
    {
	this.r=r;
	this.h=h;
	x=0;
	y=0;
	z=0;
    }

    public cylinder(double x, double y, double z, double r,double h)
    {
	this.x=x;
	this.y=y;
	this.z=z;
	this.r=r;
	this.h=h;
    }
    private double cos(double d)
    {return java.lang.Math.cos(d);}

    private double sin(double d)
    {return java.lang.Math.sin(d);}

    public ArrayList drawCylinder()
    {
	ArrayList result=new ArrayList();
	point[] p1=(new circle(x,y,z,r)).drawCir();
	point[] p2=(new circle(x,y+h,z,r)).drawCir();

	for(int i=0; i<p1.length; i++){
	    matrix m1=new matrix();
	    matrix m2=new matrix();
	    matrix m3=new matrix();

	    m1.makeLine(p1[i], p2[i]);
	    m2.makeLine(p1[i],p1[(i+1)%p1.length]);
	    m3.makeLine(p2[i],p2[(i+1)%p2.length]);

	    result.add((Object) m1);
	    result.add((Object) m2);
	    result.add((Object) m3);
	}
	return result;   
    }

    public void setX(double d)
    {x=d;}
    public void setY(double d)
    {y=d;}
    public void setZ(double d)
    {z=d;}
    public void setR(double d)
    {r=d;}
    public void setH(double d)
    {h=d;}

    public double getX()
    {return x;}
    public double getY()
    {return y;}
    public double getZ()
    {return z;}
    public double getR()
    {return r;}
    public double getH()
    {return h;}

    public String toString()
    {
	return "Center: ("+x+", "+y+", "+z+")\tRadius: "+r+"\tHeight: "+h;
    }
}
