import java.util.*;
import java.lang.*;
import javax.swing.*;
import java.io.*;
import parser.*;
import parseTables.*;
import java.awt.*;

public class gdl
{
    gui g;
    stack st;
    ArrayList coords,sliders;
    light[] lights;
    int lnum;
    boolean focal;
    double f;
    Color ambient;

    public gdl(ArrayList a)
    {
	focal=false;
	coords=new ArrayList();
	sliders=new ArrayList();
	lights=new light[5];
	lnum=0;
	g=new gui();
	st=new stack();
	Color backcol=Color.white;
	System.out.println(backcol);
	raytrace rayTrace=new raytrace();

	for(int j=0; j<a.size(); j++){
            Object o=a.get(j);
            System.out.println(o);
            String ostr=o.toString();
	    
	    /***************PUSH************/
            if(ostr.length()==4 && ostr.equals("PUSH")){
                g.getImg().getStack().push();
                st.push();
            }

	    /***************POP*************/
            else if(ostr.length()==3 && ostr.equals("POP")){
                g.getImg().getStack().pop();
                g.getImg().setRotate(false);
                matrix m=new matrix();
                m.makeIdentity();
                if(g.getImg().getStack().peek()==null){
                    g.getImg().getStack().push(m);
                    g.setM(m);
                }
                else
                    g.setM((matrix)st.peek());
            }
	    
	    /*************SAVE CS************/
	    else if(ostr.length()>=7 && ostr.substring(0,7).equals("SaveCS:")){
                opSavecs scs=(opSavecs)o;
                coord c=new coord((matrix)st.peek(),scs.getName());
                coords.add((Object) c);
                //System.out.println(c);
            }

	    /*************COLOR***************/
	    else if(ostr.length()>=10 &&ostr.substring(0,10).equals("Color: RGB")){
		opColor col=(opColor) o;
		double[] rgb=col.getRGB();
		g.getImg().setColor(new Color((int)rgb[0],
					      (int)rgb[1],
					      (int)rgb[2]));
	    }
	    /**********BACKGROUND*************/
	    else if(ostr.length()>=12 && ostr.substring(0,12).equals("Background: ")){
		opBackground back=(opBackground) o;
		double[] rgb=back.getRGB();
		backcol=new Color((int)rgb[0],
				  (int)rgb[1],
				  (int)rgb[2]);
	    }
	    /*************LIGHT***************/
	    else if(ostr.length()>=13 && ostr.substring(0,10).equals("Light: RGB")){
		opLight light=(opLight) o;
		double[] rgb=light.getRgb();
		double[] xyz=light.getLocation();
		lights[lnum]=new light(new Color((int)rgb[0],
						 (int)rgb[1],
						 (int)rgb[2]),
				       new point(xyz[0],
						 xyz[1],
						 xyz[2]));
		
		rayTrace.setLight(lights[lnum]);
		lnum++;
		g.getImg().setShading(true);
	    }
	    /************AMBIENT**************/
	    else if(ostr.length()>=9 && ostr.substring(0,9).equals("Ambient: ")){
		opAmbient am=(opAmbient) o;
		double[] rgb=am.getRgb();
		ambient=new Color((int)rgb[0],(int)rgb[1],(int)rgb[2]);
		rayTrace.setAmbient(ambient);
	    }
	    /*************SHADING**************/
	    else if(ostr.length()>=9 && ostr.substring(0,9).equals("Shading: ")){
		opShading sh=(opShading) o;
		if(sh.getType().equalsIgnoreCase("Goroud") || 
		   sh.getType().equalsIgnoreCase("Phong") ||
		   sh.getType().equalsIgnoreCase("Raytrace"))
		    g.getImg().setShade(sh.getType());
	    }
	    /**************EYE****************/
	    else if(ostr.length()>=5 && ostr.substring(0,6).equals("Eye: ")){
		opEye eye=(opEye) o;
		double[] xyz=eye.getXYZ();
		rayTrace.setEye(new point(xyz[0],xyz[1],xyz[2]));
	    }
	    /*************FOCAL***************/
	    else if(ostr.length()>=6 && ostr.substring(0,6).equals("Focal:")){
		opFocal fo=(opFocal) o;
		focal=true;
		matrix m=new matrix();
		f=fo.getValue();
		m.makeFocal(f);
		st.push(m);
		g.getImg().setFocal(focal);
	    }
	    /*************LINE****************/
            else if(ostr.length()>=4 && ostr.substring(0,4).equals("Line")){
                opLine l=(opLine) o;
                if(g.getImg().getRotate()){
                    g.drawLine(getX(l.getP1())-150,(getY(l.getP1())-150),
			       getZ(l.getP1()),getX(l.getP2())-150,
			       (getY(l.getP2())-150),getZ(l.getP2()));
                }
                else
                    g.drawLine(getX(l.getP1()),getY(l.getP1())*(-1),
			       getZ(l.getP1()),getX(l.getP2()),
			       getY(l.getP2())*(-1),getZ(l.getP2()));
            }
	    /**************BOX****************/
	    else if(ostr.length()>=3 && ostr.substring(0,4).equals("Box:")){
                opBox box=(opBox)o;
                g.drawBox(getX(box.getP1())+150,getY(box.getP1())+150,
			  getZ(box.getP1()),getX(box.getP2())+150,
			  getY(box.getP2())+150,getZ(box.getP2()));
		rayTrace.add(new boxShape(new point(getX(box.getP1())+150,
						    getY(box.getP1())+150,
						    getZ(box.getP1())),
					  new point(getX(box.getP2())+150,
						    getY(box.getP2())+150,
						    getZ(box.getP2()))));
	    }
            /************SPHERE***************/
	    else if(ostr.length()>=7 && ostr.substring(0,7).equals("Sphere:")){
                opSphere sphere=(opSphere) o;
                if(g.getImg().getRotate()){
                    g.drawSphere(getX(sphere.getCenter()),
				 getY(sphere.getCenter()),
				 getZ(sphere.getCenter()),
				 sphere.getR());
		    rayTrace.add(new sphereShape(new point(getX(sphere.getCenter()),
							   getY(sphere.getCenter()),
							   getZ(sphere.getCenter())),
						 sphere.getR()));
		}
                else{
                    g.drawSphere(getX(sphere.getCenter())+150,
				 getY(sphere.getCenter())+150,
				 getZ(sphere.getCenter()),
				 sphere.getR());
		    rayTrace.add(new sphereShape(new point(getX(sphere.getCenter())+150,
							   getY(sphere.getCenter())+150,
							   getZ(sphere.getCenter())),
						 sphere.getR()));
		}
	    }
            /*************TORUS***************/
	    else if(ostr.length()>=6 && ostr.substring(0,6).equals("Torus:")){
                opTorus torus=(opTorus) o;
                if(g.getImg().getRotate()){
                    g.drawTorus(getX(torus.getCenter()),
				getY(torus.getCenter()),
				getZ(torus.getCenter()),
				torus.getR(),torus.getr());
		    rayTrace.add(new torusShape(new point(getX(torus.getCenter()),
							  getY(torus.getCenter()),
							  getZ(torus.getCenter())),
						torus.getR(),torus.getr()));
		    }
		else{
                    g.drawTorus(getX(torus.getCenter())+150,
				getY(torus.getCenter())+150,
				getZ(torus.getCenter()),
				torus.getR(),torus.getr());
		    rayTrace.add(new torusShape(new point(getX(torus.getCenter())+150,
							  getY(torus.getCenter())+150,
							  getZ(torus.getCenter())),
						torus.getR(),torus.getr()));
		}
	    }
	    /**************MOVE***************/
	    else if(ostr.length()>=5 && ostr.substring(0,5).equals("Move:")){
                opMove move=(opMove) o;
                matrix m=new matrix();
                m.makeTrans(getX(move.getValues()),
			    getY(move.getValues())*(-1),
			    getZ(move.getValues()));
                st.multTop(m);
                if(move.getKnob()!=null){
                    JSlider ss=new JSlider(JSlider.HORIZONTAL,0,10,5);
                    ss.setMajorTickSpacing(5);
                    ss.setMinorTickSpacing(1);
                    ss.setPaintTicks(true);
                    ss.setSnapToTicks(false);
                    knob k=new knob(ss,move.getKnob());
                    sliders.add((Object) k);
                }
            }
	    /*************SCALE***************/
            else if(ostr.length()>=6 && ostr.substring(0,6).equals("Scale:")){
                opScale sc=(opScale)o;
                matrix m=new matrix();
                m.makeScale(getX(sc.getValues()),
			    getY(sc.getValues()),
			    getZ(sc.getValues()));
		st.multTop(m);
                if(sc.getKnob()!=null){
                    JSlider ss=new JSlider(JSlider.HORIZONTAL,0,10,5);
                    ss.setMajorTickSpacing(5);
                    ss.setMinorTickSpacing(1);
                    ss.setPaintTicks(true);
                    ss.setSnapToTicks(false);
                    knob k=new knob(ss,sc.getKnob());
                    sliders.add((Object) k);
                }
            }
	    /************ROTATE**************/
	    else if(ostr.length()>=7 && ostr.substring(0,7).equals("Rotate:")){
                opRotate ro=(opRotate) o;
                matrix m=new matrix();		
                if(ro.getAxis()=='x'||ro.getAxis()=='X'){
                    m.makeRX(ro.getDeg());
                    g.getImg().setRotate(true);
                    st.multTop(m);
                }
		else if(ro.getAxis()=='y' || ro.getAxis()=='Y'){
                    m.makeRY(ro.getDeg());
                    g.getImg().setRotate(true);
                    st.multTop(m);
                }
                else if(ro.getAxis()=='z' || ro.getAxis()=='Z'){
                    m.makeRZ(ro.getDeg());
                    g.getImg().setRotate(true);
                    st.multTop(m);
                }
		if(ro.getKnob()!=null){
                    JSlider ss=new JSlider(JSlider.HORIZONTAL,0,36,0);
                    ss.setMajorTickSpacing(9);
                    ss.setMinorTickSpacing(1);
                    ss.setPaintTicks(true);
                    ss.setSnapToTicks(false);
                    knob k=new knob(ss,ro.getKnob());
                    sliders.add((Object) k);
                }
            }
        }
	g.getImg().setLights(lights);
       	if(ambient==null){
	    ambient=new Color(10,10,10);
	    rayTrace.setAmbient(new Color(10,10,10));
	}
	g.getImg().setRayTrace(rayTrace);
	g.getImg().setAmbient(ambient);
	g.addSliders(sliders);
        g.setM((matrix) st.peek());
        g.getImg().apply();
        JFrame.setDefaultLookAndFeelDecorated(true);
        JFrame frame=new JFrame("Gen Kazama-Project 4");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        JComponent newContentPane=g;
        frame.setContentPane(newContentPane);
        frame.pack();
        frame.setVisible(true);
	g.setBackgroundColor(backcol);
	System.out.println("Making the sliders for the knobs");
    }
    
    public double getX(double[] d)
    {return d[0];}
    public double getY(double[] d)
    {return d[1];}
    public double getZ(double[] d)
    {return d[2];}
}
