import java.lang.*;
import java.lang.Math.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.imageio.*;

public class gimage extends JPanel implements MouseMotionListener
{
    ArrayList lines,polygons,scannedLines,curve;
    private int shape,clicks,curs;
    private int x1,y1,x2,y2,x3,y3;
    private Color c,bc,ambient;
    private matrixMult mult;
    private Image bi;
    private Polygon poly1,poly2;
    private curves current;
    private boolean rotate,focal,change,shading;
    private stack st;
    private String shade;
    private Cursor cursor;
    private light lights[];
    private debug d=new debug(true);
    private raytrace rayTrace;
    public int imagenum;

    public gimage()
    {
	super();
	lines=new ArrayList();
	curve=new ArrayList();
	polygons=new ArrayList();
	scannedLines=new ArrayList();
	rotate=false;
	change=false;
	focal=false;
	shading=false;
	mult=new matrixMult();
	shape=0;
	clicks=0;
	curs=0;
	shade="";
	imagenum=100;
	lights=new light[5];
	st=new stack();
	cursor=new Cursor(java.awt.Cursor.DEFAULT_CURSOR);
	this.setCursor(cursor);
    }

    public void clear()
    {
	lines=new ArrayList();
	curve=new ArrayList();
	scannedLines=new ArrayList();
	polygons=new ArrayList();
	System.out.println("\033[36mCleared\033[0m");
	mult=new matrixMult();
	clearBI();


	Graphics temp=bi.getGraphics();
	temp.setColor(bc);
	poly1=new Polygon();
	poly2=new Polygon();
	temp.fillRect(0,0,300,300);
	setZero();
    }

    public void translate(double deltaX, double deltaY, double deltaZ)
    {
	matrix m=new matrix();
	m.makeTrans(deltaX, deltaY, deltaZ);
	setM1(m);
	clearBI();
    }

    public void scale(double sx, double sy, double sz)
    {
	matrix m=new matrix();
	m.makeScale(sx, sy, sz);
	setM1(m);
	clearBI();
    }
    
    public void rotate(double degrees, char c)
    {
	translate(-150,-150,0);
	if(c=='x')
	    rotateX(degrees);
	else if(c=='y')
	    rotateY(degrees);
	else if(c=='z')
	    rotateZ(degrees);
	
	translate(150,150,0);
	clearBI();
	//base=mult.mult(mult.getM1(),base);
    }

    private void rotateX(double degrees)
    {
	matrix m=new matrix();
	m.makeRX(degrees);
	setM1(m);
    }

    private void rotateY(double degrees)
    {
	matrix m=new matrix();
	m.makeRY(degrees);
	setM1(m);
    }

    private void rotateZ(double degrees)
    {
	matrix m=new matrix();
	m.makeRZ(degrees);
	setM1(m);
    }

    public void apply()
    {
	if(! scannedLines.isEmpty())
	    scannedLines.clear();
	for(int i=0; i<lines.size(); i++){
	    matrix m=(matrix)lines.get(i);
	    /*if(m.getScanned()){
		System.out.print(i+"\t");
		lines.remove(i);
	    }
	    else{*/
	    //System.out.println("sdf");
	    //System.out.println("SCANed: "+m.getScanned());
	    boolean temp=m.getRotate();
	    boolean stemp=m.getScanned();
	    m=mult.mult(mult.getM1(), m);
	    m.setLine(true);
		if(temp){
		    m.setX1(m.getX1()+150);
		    m.setX2(m.getX2()+150);
		    m.setY1(m.getY1()+150);
		    m.setY2(m.getY2()+150);
		    m.setRotate(! rotate);
		    m.setScanned(stemp);
		}
	    
	    //	    System.out.println(m);
	    lines.set(i,(Object) m);
	    //	    }
	}
	/*	for(int i=0 ;i<curve.size(); i++){
		matrix m=(matrix)curve.get(i);
		m=mult.mult(mult.getM1(), m);
		m.setLine(true);
		curve.set(i, (Object) m);
	}*/
	for(int i=0; i<polygons.size();i++){
	    quad p=(quad) polygons.get(i);
	    for(int j=0; j<p.getNumSides(); j++){
		matrix m=new matrix();
		m=p.getMatrix(j);
		boolean temp=m.getRotate();
		m=mult.mult(mult.getM1(), m);
		m.setLine(true);
		if(temp){
		    m.setX1(m.getX1()+150);
		    m.setX2(m.getX2()+150);
		    m.setY1(m.getY1()+150);
		    m.setY2(m.getY2()+150);
		    m.setRotate(! rotate);
		}
		p.setMatrix(m,j);
	    }
	    p.findNormal();
	    p.findBox();
	    polygons.set(i,(Object)p);
	}
	mult=new matrixMult();
	this.update(this.getGraphics());
    }
    
    public void setM1(matrix m)
    {
	if(mult.getControl1())
	    mult.multM1(m);
	else
	    mult.setM1(m);
    }

    public void drawLine(double xx1, double yy1, double xx2, double yy2)
    {
	matrix m=new matrix();
	m.makeLine(xx1, yy1, 0, xx2, yy2, 0);
	m.setRotate(rotate);
	lines.add((Object) m);
	this.update(this.getGraphics());
	//	System.out.println("\033[31mDrew Line ("+xx1+", "+yy1+") to ("+xx2+", "+yy2+")\033[0m");
    }

    public void drawCircle(double xc, double yc, double zc, double r)
    {
        circle cir=new circle(xc,yc,zc,r);
	cir.setRotate(rotate);
	append(cir.drawCircle());
	this.update(this.getGraphics());
        //System.out.println("\033[32mDrew Circle "+cir+"\033[0m");
    }

    public void drawSphere(double xs, double ys, double zs, double r)
    {
        sphere s=new sphere(xs,ys,zs,r);
        s.setRotate(rotate);
	//append(s.drawSphere());
	s.drawSphere();
	appendPoly(s.getPolygons());
        this.update(this.getGraphics());
	//        System.out.println("\033[33mDrew Sphere "+s+"\033[0m");
    }

    public void drawTorus(double xt, double yt, double zt, double r1, double r2)
    {
	torus t=new torus(xt,yt,zt,r1,r2);
	t.setRotate(rotate);
	//	append(t.drawTorus());
	t.drawTorus();
	appendPoly(t.getPolygons());
	this.update(this.getGraphics());
	//	System.out.println("\033[34mDrew Torus "+t+"\033[0m");
    }

    public void drawCylinder(double xc,double yc,double zc,double rc, double hc)
    {
	cylinder cy=new cylinder(xc,yc,zc,rc,hc);
	append(cy.drawCylinder());
	this.update(this.getGraphics());
	//	System.out.println("\033[35mDrew Cylinder "+cy+"\033[0m");
    }

    public void drawCone(double xc, double yc, double zc, double rc, double hc)
    {
	cone cone=new cone(xc,yc,zc,rc,hc);
	append(cone.drawCone());
	this.update(this.getGraphics());
	//	System.out.println("Drew Cone "+cone);
    }

    public void drawCurve(point p1,point p2,point p3,point p4)
    {
	curves cur=new curves(p1,p2,p3,p4,curs);
	current=cur;
	appendCur(cur.drawCurve());
	this.update(this.getGraphics());
	//	System.out.println("\033[37mDrew Curve "+cur+"\033[0m");
	change=true;
    }

    public void drawBox(double bx,double by,double bz,
			double bx2,double by2,double bz2)
    {
	box box=new box(bx,by,bz,bx2,by2,bz2);
	appendPoly(box.drawBoxPoly());
	//	append(box.drawBox());
	this.update(this.getGraphics());
	System.out.println("Drew Box "+box);
    }
    
    public void paintComponent(Graphics g)
    {
	g.setColor(Color.gray);
	g.drawLine(0,this.getHeight()/2,this.getWidth(),this.getHeight()/2);
	g.drawLine(this.getWidth()/2,0,this.getWidth()/2,this.getHeight());
	if(bi==null)
	    bi=(BufferedImage)(this.createImage(300,300));
	Graphics temp=bi.getGraphics();
	temp.setColor(bc);
	temp.fillRect(0,0,300,300);

	//System.out.println("GEN "+shade);
	if(shade.equalsIgnoreCase("Raytrace")){
	    appendScanned(rayTrace.trace());
	}
	else{
	    for(int i=0; i<polygons.size();i++){
		quad p=(quad) polygons.get(i);
		if(p.getVisible())
		    if(! shading)
			appendScanned(p.scanline());
		    else if(shading)
			appendScanned(shade(p,lights[0],ambient,i));
	    }
	}
	
	for(int i=0; i<scannedLines.size();i++){
	    matrix m=(matrix) scannedLines.get(i);
	    g.setColor(m.getColor());
	    g.drawLine((int)m.getX1(),(int) m.getY1(),
		       (int) m.getX2(),(int)m.getY2());
	    
	    Graphics g2=bi.getGraphics();
	    g2.setColor(m.getColor());
	    g2.drawLine((int) m.getX1(),(int) m.getY1(),
			(int) m.getX2(),(int) m.getY2());
	}
	

	System.out.println("End of update");
    } 

    private ArrayList shade(quad p,light l, Color ambient,int y)
    {
	ArrayList result=new ArrayList();
	if(p.getBox())
	    result=shadeBox(p,l,ambient,y);
	else
	    result=shadeConv(p,l,ambient,y);
	return result;
    }

    private ArrayList shadeConv(quad p,light li,Color ambient,int num)
    {
	ArrayList result=new ArrayList();
	int left,right,min,max;
	double xl,xr,dxr,dxl,dy,y,zr,zl,dzr,dzl;
	double drl,dgl,dbl,drr,dgr,dbr,r1,g1,b1,r2,g2,b2,dr,dg,db,r,g,b;
	matrix[] lines=p.getLines();
	vector[] vertexNormals=new vector[4];
	vertexNormals=(vector[]) (p.getVertexNormals()).clone();
	vector l;
	double kd=1;
	Color[] vertexColors=new Color[4];
	int numsides=4;
	//boolean r;

	//	d.println("\n\nSHADE CONV  "+li);

	for(int i=0; i<polygons.size(); i++){
	    quad q=(quad) polygons.get(i);
	    if(i!=num)
		for(int j=0; j<4; j++){
		    if((q.getMatrix(j).getX1()==lines[0].getX1()) &&
		       (q.getMatrix(j).getY1()==lines[0].getY1()) &&
		       (q.getMatrix(j).getZ1()==lines[0].getZ1()))
			vertexNormals[0].add(q.getVertexNormal(j));
		    else if((q.getMatrix(j).getX1()==lines[1].getX1()) &&
			    (q.getMatrix(j).getY1()==lines[1].getY1()) &&
			    (q.getMatrix(j).getZ1()==lines[1].getZ1()))
			vertexNormals[1].add(q.getVertexNormal(j));
		    else if((q.getMatrix(j).getX1()==lines[2].getX1()) &&
			    (q.getMatrix(j).getY1()==lines[2].getY1()) &&
			    (q.getMatrix(j).getZ1()==lines[2].getZ1()))
			vertexNormals[2].add(q.getVertexNormal(j));
		    else if((q.getMatrix(j).getX1()==lines[3].getX1()) &&
			    (q.getMatrix(j).getX1()==lines[3].getY1()) &&
			    (q.getMatrix(j).getZ1()==lines[3].getZ1()))
			vertexNormals[3].add(q.getVertexNormal(j));
		}
	}
	
	for(int i=0; i<4; i++){
	    vertexNormals[i].normalize();
	    //d.println(i+": "+vertexNormals[i]);
	    l=new vector(li.getX()-lines[i].getX1(),
			 li.getY()-lines[i].getY1(),
			 li.getZ()-lines[i].getZ1());
	    l.normalize();
	    //d.println("L "+l);

	    r1=(li.getR()*kd*(l.dot(vertexNormals[i],l))+
		ambient.getRed()+256)%256;
	    g1=(li.getR()*kd*(l.dot(vertexNormals[i],l))+
		ambient.getGreen()+256)%256;
	    b1=(li.getR()*kd*(l.dot(vertexNormals[i],l))+
		ambient.getBlue()+256)%256;

	    //	    d.println("R: "+r1+"\nG: "+g1+"\nB: "+b1);
	    vertexColors[i]=new Color((int)r1,(int)g1,(int)b1);
	    //d.println(""+vertexColors[i]);
	}
		
	min=findLowest(lines);
	max=findHighest(lines);

	if(lines[(min+1)%numsides].getX1()<
	   lines[(min-1+numsides)%numsides].getX1()){
	    left=(min+1)%numsides;
	    right=(min-1+numsides)%numsides;
	}
	else{
	    left=(min-1+numsides)%numsides;
	    right=(min+1)%numsides;
	}
	if(max==left)
	    max=(max+1)%numsides;
	
	right=checkright(min,max,left,right);
	left=checkleft(min,max,left,right);
	min=checkmin(min,max,left,right);
	
	if(max !=(min+2)%numsides)
	    if((min+2)%numsides==right){
		int temp=right;
		right=max;
		max=temp;
	    }
	    else{
		int temp=left;
		left=max;
		max=temp;
	    }	
	
	if(lines[min].getY1()>lines[max].getY1()){
	    int temp=min;
	    min=max;
	    max=temp;
	}

	dy=1;
	xl=lines[min].getX1();
	xr=lines[min].getX1();
	zl=lines[min].getZ1();
	zr=lines[min].getZ1();

	if((lines[left].getX1()==lines[min].getX1()) &&
	   (lines[left].getY1()==lines[min].getY1()))
	    dxl=0;
	else
	    dxl=((lines[left].getX1()-lines[min].getX1())/
		 (lines[left].getY1()-lines[min].getY1()));
	
	if((lines[right].getX1()==lines[min].getX1()) &&
	   (lines[right].getY1()==lines[min].getY1()))
	    dxr=0;
	else
	    dxr=((lines[right].getX1()-lines[min].getX1())/
		 (lines[right].getY1()-lines[min].getY1()));
	
	dzl=((lines[left].getZ1()-lines[min].getZ1())/
	     (lines[left].getY1()-lines[min].getZ1()));
	dzr=((lines[right].getZ1()-lines[min].getZ1())/
	     (lines[right].getY1()-lines[min].getY1()));

	if(dxr==Double.POSITIVE_INFINITY ||dxr==Double.NEGATIVE_INFINITY
	   || dxr==Double.NaN){
	    dxr=((lines[max].getX1()-lines[right].getX1())/
		 (lines[max].getY1()-lines[right].getY1()));
	    xr=lines[right].getX1();
	    zr=lines[right].getZ1();
	}
	if(dxl==Double.POSITIVE_INFINITY || dxl==Double.NEGATIVE_INFINITY 
	   || dxl==Double.NaN){
	    dxl=0;
	    xl=lines[left].getX1();
	    zl=lines[left].getX1();
	}

	//	d.println("\nMIN: "+min+"\tLEFT: "+left+"\tRIGHT: "+right+"\tMAX: "+max);

	r1=vertexColors[min].getRed();
	r2=vertexColors[min].getRed();
	g1=vertexColors[min].getGreen();
	g2=vertexColors[min].getGreen();
	b1=vertexColors[min].getBlue();
	b2=vertexColors[min].getBlue();

	if(lines[left].getY1()==lines[min].getY1())
	    if(lines[left].getX1()==lines[min].getX1()){
		drl=0;
		dbl=0;
		dgl=0;
	    }
	    else{
	    drl=(vertexColors[left].getRed()-vertexColors[min].getRed())/
		(lines[left].getX1()-lines[min].getX1());
	    dbl=(vertexColors[left].getBlue()-vertexColors[min].getBlue())/
		(lines[left].getX1()-lines[min].getX1());
	    dgl=(vertexColors[left].getGreen()-vertexColors[min].getGreen())/
		(lines[left].getX1()-lines[min].getX1());
	    }
	else{
	    drl=(vertexColors[left].getRed()-vertexColors[min].getRed())/
		(lines[left].getY1()-lines[min].getY1());
	    dbl=(vertexColors[left].getBlue()-vertexColors[min].getBlue())/
		(lines[left].getY1()-lines[min].getY1());
	    dgl=(vertexColors[left].getGreen()-vertexColors[min].getGreen())/
		(lines[left].getY1()-lines[min].getY1());
	}
	if(lines[right].getY1()==lines[min].getY1())
	    if(lines[right].getX1()==lines[min].getX1()){
		drr=0;
		dgr=0;
		dbr=0;
	    }
	    else{
		drr=(vertexColors[right].getRed()-vertexColors[min].getRed())/
		    (lines[right].getX1()-lines[min].getX1());
		dgr=(vertexColors[right].getGreen()-vertexColors[min].getGreen())/
		    (lines[right].getX1()-lines[min].getX1());
		dbr=(vertexColors[right].getBlue()-vertexColors[min].getBlue())/
		    (lines[right].getX1()-lines[min].getX1());
	    }
	else{
	    drr=(vertexColors[right].getRed()-vertexColors[min].getRed())/
		(lines[right].getY1()-lines[min].getY1());
	    dgr=(vertexColors[right].getGreen()-vertexColors[min].getGreen())/
		(lines[right].getY1()-lines[min].getY1());
	    dbr=(vertexColors[right].getBlue()-vertexColors[min].getBlue())/
		(lines[right].getY1()-lines[min].getY1());
	}
	
	/*d.println("Min: "+lines[min]+min+"\nLeft: "+lines[left]+left+"\nMax: "+lines[max]+max+"\nRight: "+lines[right]+right);

	d.println("DXL: "+dxl+"\nDXR "+dxr);
	d.println("XL "+xl+"\nXR: "+xr);
	d.println("Y1: "+(int)lines[min].getY1()+"\nY2: "+(int)lines[max].getY1());
	*/
	//d.println("DRL: "+drl+"\nDGL: "+dgl+"\nDBL: "+dbl+"\nDRR: "+drr+"\nDGR: "+dgr+"\nDBR: "+dbr);

	//	System.out.println("R1 "+r1+" G1 "+g1+" B1 "+b1);


	for(y=lines[min].getY1()+1;y<=(int)lines[max].getY1(); y++){
	    dr=0;
	    dg=0;
	    db=0;
	    if((xr-xl)!=0){
		dr=(r2-r1)/(xr-xl);
		dg=(g2-g1)/(xr-xl);
		db=(b2-b1)/(xr-xl);
		
		//	System.out.println("\ndR "+dr+"\ndG "+dg+"\ndB "+db);
	    }
	    r=r1;
	    g=g1;
	    b=b1;
	    
	    for(int i=(int)xl; i<=(int)xr; i++){
		matrix m=new matrix(i,y,zl,i,y,zr);
		m.setScanned(true);
		//	d.println("("+((int)round(r))+","+((int)round(g))+","+((int)round(b))+")");
		m.setColor(new Color((int)round(r),(int)round(g),(int)round(b)));
		//		System.out.println(m);
		result.add((Object) m);
		r+=dr;
		g+=dg;
		b+=db;
	    }
	    xl+=dxl;
	    xr+=dxr;
	    zl+=dzl;
	    zr+=dzr;
	    r1=round(r1+drl);
	    g1=round(g1+dgl);
	    b1=round(b1+dbl);
	    r2=round(r2+drr);
	    g2=round(g2+dgr);
	    b2=round(b2+dbr);

	    //d.println("Y "+y+"\nDXR: "+dxr+"\nDXL: "+dxl+"\nXL "+xl+"\nXR "+xr+"\n");
	    if(y>=lines[left].getY1()){
		left=(left+1)%numsides;
		if(left==min)
		    left=max;
		dxl=((xl-lines[left].getX1())/(y-lines[left].getY1()));
		drl=(vertexColors[max].getRed()-r1)/(lines[left].getY1()-y);
		dgl=(vertexColors[max].getGreen()-g1)/(lines[left].getY1()-y);
		dbl=(vertexColors[max].getBlue()-b1)/(lines[left].getY1()-y);
		//		d.println("change\nDRL: "+drl+"\nDGL: "+dgl+"\nDBL: "+dbl);
		if(dxl==Double.POSITIVE_INFINITY || 
		   dxl==Double.NEGATIVE_INFINITY || dxl==Double.NaN)
		    dxl=0;
		    //    d.println("Exception left "+left);
	       
		dzl=(zl-lines[left].getZ1())/(y-lines[left].getY1());
		//	d.println("Change left");
	    }
	    if(y>=lines[right].getY1()){
		right=max;
		//r=false;
		dxr=((xr-lines[right].getX1())/(y-lines[right].getY1()));

		drr=(vertexColors[max].getRed()-r1)/(lines[right].getY1()-y);
		dgr=(vertexColors[max].getGreen()-g1)/(lines[right].getY1()-y);
		dbr=(vertexColors[max].getBlue()-b1)/(lines[right].getY1()-y);
		//d.println("change\nDRR: "+drr+"\nDGR: "+dgr+"\nDBR: "+dbr);

		if(dxr==Double.POSITIVE_INFINITY ||
		   dxr==Double.NEGATIVE_INFINITY || dxr==Double.NaN){
		    dxr=((lines[max].getX1()-lines[right].getX1())/
			 (lines[max].getY1()-lines[right].getY1()));
		    dxr=0;
		    //  d.println("Exception right");
		}
		dzr=(zr-lines[right].getZ1())/(y-lines[right].getY1());
		//d.println("Change right "+right);
	    }
	}
	return result;
    }
    
    protected ArrayList shadeBox(quad p,light li,Color ambient,int num)
    {
	ArrayList result=new ArrayList();
	double y,xl,xr,z;
	int min1,min2,max1,max2,rmin1,rmin2,gmin1,gmin2,bmin1,bmin2;
	double drl,dgl,dbl,drr,dgr,dbr;
	double r1,g1,b1,r2,g2,b2,dr,dg,db,r,g,b;
	matrix[] lines=p.getLines();
	vector[] vertexNormals=new vector[4];
	Color[] vertexColors=new Color[4];
	vertexNormals=(vector[]) (p.getVertexNormals()).clone();
	vector l;
	double kd=1;
	
	//	d.println("SHADE BOX");
	
	for(int i=0; i<polygons.size(); i++){
	    quad q=(quad) polygons.get(i);
	    if(i!=num)
		for(int j=0; j<4; j++){
		    if((q.getMatrix(j).getX1()==lines[0].getX1()) &&
		       (q.getMatrix(j).getY1()==lines[0].getY1()) &&
		       (q.getMatrix(j).getZ1()==lines[0].getZ1()))
			vertexNormals[0].add(q.getVertexNormal(j));
		    else if((q.getMatrix(j).getX1()==lines[1].getX1()) &&
			    (q.getMatrix(j).getY1()==lines[1].getY1()) &&
			    (q.getMatrix(j).getZ1()==lines[1].getZ1()))
			vertexNormals[1].add(q.getVertexNormal(j));
		    else if((q.getMatrix(j).getX1()==lines[2].getX1()) &&
			    (q.getMatrix(j).getY1()==lines[2].getY1()) &&
			    (q.getMatrix(j).getZ1()==lines[2].getZ1()))
			vertexNormals[2].add(q.getVertexNormal(j));
		    else if((q.getMatrix(j).getX1()==lines[3].getX1()) &&
			    (q.getMatrix(j).getX1()==lines[3].getY1()) &&
			    (q.getMatrix(j).getZ1()==lines[3].getZ1()))
			vertexNormals[3].add(q.getVertexNormal(j));
		}
	}
	
	for(int i=0; i<4; i++){
	    vertexNormals[i].normalize();
	    //   d.println(i+": "+vertexNormals[i]);
	    l=new vector(li.getX()-lines[i].getX1(),
			 li.getY()-lines[i].getY1(),
			 li.getZ()-lines[i].getZ1());
	    l.normalize();
	    r1=(li.getR()*kd*(l.dot(vertexNormals[i],l))+
			ambient.getRed()+256)%256;
	    g1=(li.getR()*kd*(l.dot(vertexNormals[i],l))+
			ambient.getGreen()+256)%256;
	    b1=(li.getR()*kd*(l.dot(vertexNormals[i],l))+
			ambient.getBlue()+256)%256;
	    //System.out.println("R: "+r1+"\nG: "+g1+"\nB: "+b1);
	    vertexColors[i]=new Color((int)r1,(int)g1,(int)b1);
	    //  d.println(""+vertexColors[i]);
	}
	
	min1=0;
	min2=0;
	max1=0;
	max2=0;
	
	for(int i=0; i<lines.length; i++){
            if(lines[(i+1)%lines.length].getY1()<lines[min1].getY1())
                min1=(i+1)%lines.length;
            if(lines[(i+1)%lines.length].getY1()>lines[max1].getY1())
                max1=(i+1)%lines.length;
        }
        if(lines[(min1+1)%lines.length].getY1()==lines[min1].getY1())
            min2=(min1+1)%lines.length;
        else if(lines[(min1-1+lines.length)%lines.length].getY1()==
                lines[min1].getY1())
            min2=(min1-1+lines.length)%lines.length;
	
	if(lines[(max1+1)%lines.length].getY1()==lines[max1].getY1())
            max2=(max1+1)%lines.length;
        else if(lines[(max1-1+lines.length)%lines.length].getY1()==
                lines[max1].getY1())
            max2=(max1-1+lines.length)%lines.length;
	
        xl=lines[min1].getX1();
        xr=lines[min2].getX1();
	z=lines[min1].getZ1();
        
	rmin1=vertexColors[min1].getRed();
	rmin2=vertexColors[min2].getRed();
	gmin1=vertexColors[min1].getGreen();
	gmin2=vertexColors[min2].getGreen();
	bmin1=vertexColors[min1].getBlue();
	bmin2=vertexColors[min1].getBlue();

      	drl=(vertexColors[max1].getRed()-vertexColors[min1].getRed())/
	    (lines[max1].getY1()-lines[min1].getY1());
	drr=(vertexColors[max2].getRed()-vertexColors[min2].getRed())/
	    (lines[max2].getY1()-lines[min2].getY1());
	dgl=(vertexColors[max1].getGreen()-vertexColors[min1].getGreen())/
	    (lines[max1].getY1()-lines[min1].getY1());
	dgr=(vertexColors[max2].getGreen()-vertexColors[min2].getGreen())/
	    (lines[max2].getY1()-lines[min2].getY1());
	dbl=(vertexColors[max1].getBlue()-vertexColors[min1].getBlue())/
	    (lines[max1].getY1()-lines[min1].getY1());
	dbr=(vertexColors[max2].getBlue()-vertexColors[min2].getBlue())/
	    (lines[max2].getY1()-lines[min2].getY1());

	//d.println("DRL: "+drl+"\nDRR: "+drr+"\nDGL: "+dgl+"\nDGR"+dgr+"\nDBL: "+dbl+"\nDBR: "+dbr);
	
	//d.println("Min1: "+min1+" "+vertexColors[min1]+"\nMin2: "+min2+" "+vertexColors[min2]+"\nMax1: "+max1+" "+vertexColors[max1]+"\nMax2: "+max2+" "+vertexColors[max2]);

	r1=vertexColors[min1].getRed();
	g1=vertexColors[min1].getGreen();
	b1=vertexColors[min1].getBlue();
	r2=vertexColors[min2].getRed();
	g2=vertexColors[min2].getGreen();
	b2=vertexColors[min2].getBlue();
	
	for(y=lines[min1].getY1();y<=lines[max1].getY1();y++){
	    dr=(r2-r1)/(lines[min2].getX1()-lines[min1].getX1());
	    dg=(g2-g1)/(lines[min2].getX1()-lines[min1].getX1());
	    db=(b2-b1)/(lines[min2].getX1()-lines[min1].getX1());
	    r=r1;
	    g=g1;
	    b=b1;
	    
	    for(double d=xl; d<=xr; d++){
		matrix m=new matrix(d,y,z,d,y,z);
		m.setColor(new Color((int)round(r),(int)round(g),(int)round(b)));
		m.setScanned(true);
		//System.out.println("("+((int)round(r))+","+((int)round(g))+","+((int)round(b))+")");
		result.add((Object)m);
		r+=dr;
		g+=dg;
		b+=db;
	    }
	    r1=round(r1+drl);
	    g1=round(g1+dgl);
	    b1=round(b1+dbl);
	    r2=round(r2+drr);
	    g2=round(g2+dgr);
	    b2=round(b2+dbr);
	}
	return result;
    }
    
    private double round(double d)
    {
	if(d<=0)
	    d=0;
	else if(d>=255)
	    d=255;
	return d;
    }

    public int findLowest(matrix [] lines)
    {
	int min=0;
	for(int i=0; i<lines.length; i++)
	    if(lines[(i+1)%lines.length].getY1()<lines[min].getY1())
		min=(i+1)%lines.length;
	return min;
    }
    
    public int findHighest(matrix[] lines)
    {
	int max=0;
	for(int i=0; i<lines.length; i++)
	    if(lines[i].getY1()>lines[max].getY1())
		max=i;
	return max;
    }

    private int checkright(int min,int max, int left, int right)
    {
	if(right==max || right==left || right==min)
	    right=6-(left+max+min);
	return right;
    }
    
    private int checkleft(int min, int max, int left, int right)
    {
	if(left==max || left==min)
	    left=6-(right+max+min);
	return left;
    }

    private int checkmin(int min,int max, int left,int right)
    {
	if(min==max)
	    min=6-(max+left+right);
	return min;
    }

    public void replace()
    {
	curve=new ArrayList();
	drawPolygons((int)current.getP2().getX(),(int)current.getP2().getY(),(int)current.getP3().getX(),(int)current.getP3().getY(),10);
	drawCurve(current.getP1(),current.getP2(),current.getP3(),current.getP4());
    }	    
	    
    private void clearBI()
    {bi=(BufferedImage)(this.createImage(300,300));}
    
    private void append(ArrayList a)
    {
	for(int i=0;i<a.size();i++)
	    lines.add(a.get(i));
    }

    private void appendScanned(ArrayList a)
    {
	for(int i=0; i<a.size(); i++)
	    scannedLines.add(a.get(i));
    }

    private void appendCur(ArrayList a)
    {
	if(curve.size()!=0){
	    append(curve);
	    curve=new ArrayList();
	}
	for(int i=0;i<a.size();i++)
	    curve.add(a.get(i));
    }
    private void appendPoly(ArrayList a)
    {
	for(int i=0; i<a.size(); i++)
	    polygons.add(a.get(i));
    }
    public void drawPolygons(int xx1,int yy1,int xx2,int yy2,int size)
    {
        int[] xpoints1=new int[4];
        int[] ypoints1=new int[4];
        xpoints1[0]=xx1; ypoints1[0]=yy1;
        xpoints1[1]=xx1; ypoints1[1]=yy1+size;
        xpoints1[2]=xx1+size; ypoints1[2]=yy1+size;
        xpoints1[3]=xx1+size; ypoints1[3]=yy1;

        int[] xpoints2=new int[4];
        int[] ypoints2=new int[4];
        xpoints2[0]=xx2; ypoints2[0]=yy2;
        xpoints2[1]=xx2; ypoints2[1]=yy2+size;
        xpoints2[2]=xx2+size; ypoints2[2]=yy2+size;
        xpoints2[3]=xx2+size; ypoints2[3]=yy2;

        poly1=new Polygon(xpoints1, ypoints1, 4);
        poly2=new Polygon(xpoints2, ypoints2, 4);

	Graphics g=this.getGraphics();
	g.setColor(c);
	g.fillPolygon(poly1);
        g.fillPolygon(poly2);
    }

    public void mouseMoved(MouseEvent e)
    {
	if(e.getX()>40 && e.getX()<260 && e.getY()<260 && e.getY()>40)
            cursor=new Cursor(java.awt.Cursor.DEFAULT_CURSOR);
        else{
            if((e.getX()<50 || e.getX()>250)&&(e.getY()>100 && e.getY()<200))
                cursor=new Cursor(java.awt.Cursor.CROSSHAIR_CURSOR);
            else if((e.getX()>100&&e.getX()<200)&&(e.getY()<50||e.getY()>250))
                cursor=new Cursor(java.awt.Cursor.CROSSHAIR_CURSOR);
            else if(e.getX()>150 && e.getY()>150)
                cursor=new Cursor(java.awt.Cursor.SE_RESIZE_CURSOR);
            else if(e.getX()<150 && e.getY()>150)
                cursor=new Cursor(java.awt.Cursor.SW_RESIZE_CURSOR);
            else if(e.getX()<150 && e.getY()<150)
                cursor=new Cursor(java.awt.Cursor.NW_RESIZE_CURSOR);
            else if(e.getX()>150 && e.getY()<150)
                cursor=new Cursor(java.awt.Cursor.NE_RESIZE_CURSOR);
        }
        this.setCursor(cursor);
    }
    
    public void mouseDragged(MouseEvent e)
    {}

    public void setZero()
    {
	x1=0;
	y1=0;
	x2=0;
	y2=0;
	x3=0;
	y3=0;
	clicks=0;
    }
    
    public double distance(double xx1, double xx2, double yy1, double yy2)
    {
	return java.lang.Math.sqrt(java.lang.Math.pow(xx1-xx2,2)+java.lang.Math.pow(yy1-yy2,2));
    }
    public void setBC(Color color)
    {bc=color;}
    public void setColor(Color color)
    {c=color;}
    public void setAmbient(Color color)
    {ambient=color;}
    public void setShade(String shade)
    {this.shade=shade;}
    public void setStack(stack st)
    {this.st=st;}
    public void setShape(int i)
    {shape=i;}
    public void setLights(light[] lights)
    {this.lights=lights;}
    public void setRayTrace(raytrace rayTrace)
    {this.rayTrace=rayTrace;}
    public void setRotate(boolean b)
    {rotate=b;}
    public void setFocal(boolean b)
    {focal=b;}
    public void setShading(boolean b)
    {shading=b;}
    public void setChange(boolean b)
    {
	change=b;
	poly1=new Polygon();
	poly2=new Polygon();
    }

    public ArrayList getLines(ArrayList a)
    {return lines;}
    public Color getColor()
    {return c;}
    public Color getBC()
    {return bc;}
    public curves getCurrent()
    {return current;}
    public Polygon getPoly1()
    {return poly1;}
    public Polygon getPoly2()
    {return poly2;}
    public int getShape()
    {return shape;}
    public light[] getLights()
    {return lights;}
    public BufferedImage getBi()
    {return (BufferedImage) bi;}
    public Dimension getPreferredSize()
    {return new Dimension(300,300);}
    public boolean getRotate()
    {return rotate;}
    public boolean getFocal()
    {return focal;}       
    public boolean getShading()
    {return shading;}
    public stack getStack()
    {return st;}
    public String getShade()
    {return shade;}
        
    public String toString()
    {
        String result="";
        for(int i=0; i<lines.size(); i++)
	    result+=((matrix) lines.get(i))+"\n";
        return result;
    }
}
