import java.lang.*;
import java.util.*;
import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class matrix
{
    private double[][] m;
    private int index,curve;
    private boolean line,rotate,scanned;
    private Color c;
    private double f;

    public matrix()
    {
	m=new double[4][4];
	index=0;
	curve=0;
	line=false;
	rotate=false;
	f=1;
    }

    public matrix(double[][] d)
    {
	m=d;
	index=d.length;
	line=false;
	curve=0;
	rotate=false;
	scanned=false;
	f=1;
    }

    public matrix(int size)
    {
	m=new double[4][size];
	line=false;
	curve=0;
	rotate=false;
	scanned=false;
	f=1;
    }

    public matrix(double x1,double y1,double z1,double x2,double y2,double z2)
    {
	makeLine(x1,y1,z1,x2,y2,z2);
	line=true;
	curve=0;
	rotate=false;
	scanned=false;
	f=1;
    }

    public matrix(point p1, point p2)
    {
	makeLine(p1,p2);
	line=true;
	curve=0;
	rotate=false;
	scanned=false;
	f=1;
    }

    public void set(int x, int y, double d)
    {m[x][y]=d;}

    public double get(int x, int y)
    {return m[x][y];}

    public void add(int[] data)
    {
        if(data.length==4){
            for(int i=0; i<data.length; i++)
                m[index][i]=data[i];
            index++;
        }
    }

    public void add(double i0, double i1, double i2, double i3)
    {
        m[index][0]=i0;
        m[index][1]=i1;
        m[index][2]=i2;
        m[index][3]=i3;
        index++;
    }

    public void makeIdentity()
    {
	double[][] temp={{1,0,0,0},
			 {0,1,0,0},
			 {0,0,1,0},
			 {0,0,0,1}};
	m=temp;
	line=false;
    }

    public void makeScale(double sx, double sy, double sz)
    {
	double[][] temp={{sx,0,0,0},
			 {0,sy,0,0},
			 {0,0,sz,0},
			 {0,0,0,1}};
	m=temp;
	line=false;
    }

    public void makeTrans(double x, double y, double z)
    {
        double[][] temp={{1,0,0,x},
                         {0,1,0,y},
                         {0,0,1,z},
                         {0,0,0,1}};
        m=temp;
	line=false;
    }

    public void makeRX(double degrees)
    {
        double rads=(degrees)*(java.lang.Math.PI/180);
        double[][] temp={{1,0,0,0},
                         {0,cos(rads), -sin(rads),0},
                         {0,sin(rads),cos(rads),0},
                         {0,0,0,1}};
        m=temp;
	line=false;
    }

    public void makeRY(double degrees)
    {
        double rads=(degrees)*(java.lang.Math.PI/180);
        double[][] temp={{cos(rads),0,sin(rads),0},
                         {0,1,0,0},
                         {-sin(rads),0,cos(rads),0},
                         {0,0,0,1}};
        m=temp;
	line=false;
    }

    public void makeRZ(double degrees)
    {
        double rads=(degrees)*(java.lang.Math.PI/180);
        double[][] temp={{cos(rads), -sin(rads), 0,0},
                         {sin(rads), cos(rads),0,0},
                         {0,0,1,0},
                         {0,0,0,1}};
        m=temp;
	line=false;
    }

    public void makeLine(double x1, double y1, double z1, double x2, double y2, double z2)
    {
	double[][] temp={{x1,x2},
			 {y1,y2},
			 {z1,z2},
			 {1,1}};
	m=temp;
	line=true;
    }
    
    public void makeLine(point p1, point p2)
    {
	double[][] temp={{p1.getX(),p2.getX()},
			 {p1.getY(),p2.getY()},
			 {p1.getZ(),p2.getZ()},
			 {1,1}};
	m=temp;
	line=true;
    }

    public void makeFocal(double f)
    {
	double[][] temp={{1,0,0,0},
			 {0,1,0,0},
			 {0,0,0,1/f},
			 {0,0,1/f,0}};
	m=temp;
    }

    public void multiplyAll()
    {
	for(int i=0;i<m.length; i++)
	    for(int j=0;j<m[0].length; j++)
		m[i][j]=m[i][j]*f;
    }

    public void multFocal()
    {
	if(line){
	    setX1(getX1()*f/getZ1());
	    setX2(getX2()*f/getZ2());
	    setY1(getY1()*f/getZ1());
	    setY2(getY2()*f/getZ2());
	    setZ1(1/getZ1());
	    setZ2(1/getZ2());
	    m[0][3]=1;
	    m[1][3]=1;
	}
    }
    
    public void setInt()
    {
	for(int i=0; i<m.length; i++)
	    for(int j=0; j<m[0].length;j++)
		m[i][j]=(int)m[i][j];
    }

    private double cos(double d)
    {return java.lang.Math.cos(d);}
    private double sin(double d)
    {return java.lang.Math.sin(d);}
    
    public void setCurve(int cur)
    {curve=cur;}
    public void setScanned(boolean b)
    {scanned=b;}
    public void setLine(boolean b)
    {line=b;}
    public void setDoubles(double[][] d)
    {m=d;}
    public void setColor(Color color)
    {c=color;}
    public void setRotate(boolean b)
    {rotate=b;}
    public void setNum(int r, int c,double d)
    {m[r][c]=d;}
    public void setFocal(double d)
    {f=d;}
    public void setX1(double d)
    {if(line) m[0][0]=d;}
    public void setX2(double d)
    {if(line) m[0][1]=d;}
    public void setY1(double d)
    {if(line) m[1][0]=d;}
    public void setY2(double d)
    {if(line) m[1][1]=d;}
    public void setZ1(double d)
    {if(line) m[2][0]=d;}
    public void setZ2(double d)
    {if(line) m[2][1]=d;}

    public int numRows()
    {return m.length;}
    public int numCols()
    {return m[0].length;}
    public boolean getRotate()
    {return rotate;}
    public boolean isLine()
    {return line;}

    public int getCurve()
    {return curve;}
    public double[][] getDoubles()
    {return m;}
    public Color getColor()
    {return c;}
    public double getFocal()
    {return f;}    
    public double getNum(int r, int c)
    {return m[r][c];}
    public double getX1()
    {
	if(line==false)
	    return 0;
	return m[0][0];
    }

    public double getX2()
    {
	if(line==false)
	    return 0;
	return m[0][1];
    }

    public double getY1()
    {
	if(line==false)
	    return 0;
	return m[1][0];
    }

    public double getY2()
    {
	if(line==false)
	    return 0;
	return m[1][1];
    }

    public double getZ1()
    {
	if(line==false)
	    return 0;
	return m[2][0];
    }

    public double getZ2()
    {
	if(line==false)
	    return 0;
	return m[2][1];
    }
    public point getP1()
    {return new point(getX1(),getY1(),getZ1());}
    public point getP2()
    {return new point(getX2(),getY2(),getZ2());}
    public double getSlope()
    {return ((getY2()-getY1())/(getX2()-getX1()));}
    public vector getVectorSlope()
    {return new vector(getX2()-getX1(),getY2()-getY1(),getZ2()-getZ1());}
    public boolean getScanned()
    {return scanned;}
       
    public String toString()
    {
	String result="";
	if(line)
	    result+="("+getX1()+", "+getY1()+", "+getZ1()+")\t"+
		    "("+getX2()+", "+getY2()+", "+getZ2()+")\n";
	else
	    for(int i=0; i<m.length; i++){
		for(int j=0;j<m[0].length; j++)
		    result+=m[i][j]+"\t";
		result+="\n";
	    }
	return result;
    }
}

class point
{
    private double x,y,z;

    public point()
    {
	x=0;
	y=0;
	z=0;
    }

    public point(double x, double y, double z)
    {
	this.x=x;
	this.y=y;
	this.z=z;
    }

    public matrix makeMatrix()
    {
	double d[][]=new double[1][4];
	d[0][0]=x;
	d[0][1]=y;
	d[0][2]=z;
	d[0][3]=1;
	return new matrix(d);
    }

    public void setX(double d)
    {x=d;}
    public void setY(double d)
    {y=d;}
    public void setZ(double d)
    {z=d;}

    public double x()
    {return x;}
    public double y()
    {return y;}
    public double z()
    {return z;}

    public double getX()
    {return x;}
    public double getY()
    {return y;}
    public double getZ()
    {return z;}

    public String toString()
    {
	return "Point: ("+x+", "+y+", "+z+")";
    }
}

class coord
{
    private matrix m;
    private String name;
    
    public coord()
    {
	m=new matrix();
	m.makeIdentity();
	name="";
    }
    
    public coord(matrix m, String name)
    {
	this.m=m;
	this.name=name;
    }
    
    public void setM(matrix m)
    {this.m=m;}
    public void setName(String name)
    {this.name=name;}

    public matrix getM()
    {return m;}
    public String getName()
    {return name;}

    public String toString()
    {return name+"\n"+m;}
}
