class matrixMult
{
    private matrix m1, m2;
    private boolean control1, control2;
    //m1-all transformation
    //m2-all points

    public matrixMult()
    {
	control1=false;
	control2=false;
    }

    public matrixMult(matrix num1, matrix num2)
    {
	m1=num1;
	m2=num2;
	control1=true;
	control2=true;
    }

    public void setM1(matrix num1)
    {
	m1=num1;
	control1=true;
    }
    
    public void setM2(matrix num2)
    {
	m2=num2;
	control2=true;
    }

    public matrix getM1()
    {return m1;}

    public matrix getM2()
    {return m2;}

    public boolean getControl1()
    {return control1;}

    public boolean getControl2()
    {return control2;}
    
    public void multM1(matrix num1)
    {
	m1=mult(num1, m1);
    }
    
    public matrix mult(matrix num1, matrix num2)
    {
	matrix temp=new matrix(new double[num1.numRows()][num2.numCols()]);
	for(int i=0;i<temp.numRows();i++)
	    for(int j=0; j<temp.numCols();j++)
		temp.set(i,j,multhelper(num1, num2, i,j));
	return temp;
    }
    
    private double multhelper(matrix num1, matrix num2, int x, int y) 
    {
	double result=0;
	for(int i=0; i<num1.numCols();i++)
	    result+=(num1.get(x,i))*(num2.get(i,y));
	return result;
    }

    public matrix subtract(matrix num1,matrix num2)
    {
	double[][] d=new double[num1.numRows()][num1.numCols()];
	matrix result=new matrix(d);
	for(int i=0; i<result.numRows(); i++)
	    for(int j=0; j<result.numCols(); j++)
		result.setNum(i,j,num1.getNum(i,j)-num2.getNum(i,j));
	return result;
    }

    public point subtract(point p1, point p2)
    {
	return (new point(p1.x()-p2.x(),p1.y()-p2.y(),p1.z()-p2.z()));
    }

    public point cross(point p1, point p2)
    {
	double x=(p1.y()*p2.z()-p1.z()*p2.y());
	double y=(p1.z()*p2.x()-p1.x()*p2.z());
	double z=(p1.x()*p2.y()-p1.y()*p2.x());
	return (new point(x,y,z));
    }

    public String toString()
    {
	return m1+"\n"+m2;
    }
}
