import java.lang.*;
import java.util.*;
import java.awt.*;

public class polygon
{
    protected matrix[] lines;
    protected int numsides;
    protected Color c;
    protected boolean scanned,lighting;
    protected double ka,kd;
    protected debug d=new debug(false);
	protected String shape;
	
    public polygon()
    {
	scanned=false;
	lighting=false;
    }

    public polygon(int num)
    {
	numsides=num;
	lines=new matrix[numsides];
	scanned=false;
	lighting=false;
    }

    public polygon(matrix[] lines)
    {
	this.lines=lines;
	numsides=lines.length;
	scanned=false;
	lighting=false;
    }

    public polygon(ArrayList a)
    {
	lines=new matrix[a.size()];
	for(int i=0 ;i<a.size(); i++)
	    lines[i]=(matrix)a.get(i);
	numsides=lines.length;
    }
    
    public polygon(matrix[] lines,String shape)
    {
	this.lines=lines;
	numsides=lines.length;
	scanned=false;
	lighting=false;
	this.shape=shape;
    }

    public polygon(ArrayList a,String shape)
    {
	lines=new matrix[a.size()];
	for(int i=0 ;i<a.size(); i++)
	    lines[i]=(matrix)a.get(i);
	numsides=lines.length;
	this.shape=shape;
    }
	
    public void setLines(matrix[] lines)
    {
	this.lines=lines;
	numsides=lines.length;
    }
    public void setNumSides(int numsides)
    {this.numsides=numsides;}
    public void setMatrix(matrix m, int i)
    {lines[i]=m;}
    public void setColor(Color c)
    {this.c=c;}
    public void setScanned(boolean b)
    {scanned=b;}
    public void setLighting(boolean b)
    {lighting=b;}
    public void setKA(double d)
    {ka=d;}
    public void setDiffuseConstant(double d)
    {kd=d;}
	public void setShape(String s)
	{shape=s;}
	
    public matrix[] getLines()
    {return lines;}
    public int getNumSides()
    {return numsides;}
    public matrix getMatrix(int i)
    {return lines[i];}
    public Color getColor()
    {return c;}
    public boolean getScanned()
    {return scanned;}
    public boolean getLighting()
    {return lighting;}
    public double getKA()
    {return ka;}
    public double getDiffuseConstant()
    {return kd;}
	public String getShape()
	{return shape;}
	
    public String toString()
    {
	String result=numsides+"\n";
	for(int i=0;i<lines.length;i++)
	    result+=lines[i]+"\n";
	return result;
    }
}

class quad extends polygon
{
    private boolean visible,box;
    private vector normal;
    private vector vertexNormals[];

    public quad()
    {
	super();
	visible=true;
    }

    public quad(matrix[] lines)
    {
	super(lines);
	visible=true;
	findNormal();
	findBox();
	findVertexNormals();
    }

	public quad(matrix[] lines, String s)
	{
	super(lines,s);
	visible=true;
	findNormal();
	findBox();
	findVertexNormals();
	}
	
    public void findBox()
    {
	double n=java.lang.Double.NaN;
	double pos=java.lang.Double.POSITIVE_INFINITY;
	double neg=java.lang.Double.NEGATIVE_INFINITY;
	for(int i=0; i<lines.length; i++){
	    if(lines[i].getSlope()==0){
		if((lines[(i+1)%lines.length].getSlope()==n ||
		    lines[(i+1)%lines.length].getSlope()==neg ||
		    lines[(i+1)%lines.length].getSlope()==pos) &&
		   (lines[(i-1+lines.length)%lines.length].getSlope()==n ||
		    lines[(i-1+lines.length)%lines.length].getSlope()==neg ||
		    lines[(i-1+lines.length)%lines.length].getSlope()==pos))
		    box=true;
	    }
	    else if(lines[i].getSlope()==n ||
		    lines[i].getSlope()==neg ||
		    lines[i].getSlope()==pos){
		if(lines[(i+1)%lines.length].getSlope()==0 &&
		   lines[(i-1+lines.length)%lines.length].getSlope()==0)
		    box=true;
	    }
	    else{
		box=false;
		break;
	    }
	}
    }
    
    private void setInt()
    {
	for(int i=0; i<lines.length;i++)
	    lines[i].setInt();
    }

    public void findNormal()
    {
	vector v1, v2;

	v1=new vector(lines[0].getX1()-lines[1].getX1(),
		      lines[0].getY1()-lines[1].getY1(),
		      lines[0].getZ1()-lines[1].getZ1());
	v2=new vector(lines[3].getX1()-lines[0].getX1(),
		      lines[3].getY1()-lines[0].getY1(),
		      lines[3].getZ1()-lines[0].getZ1());
	
	normal=v1.cross(v1,v2);
	normal.normalize();
	if(normal.getZ()<=0)
	    visible=false;
	else
	    visible=true;
    }

    private void findVertexNormals()
    {
	vertexNormals=new vector[4];
	vector a,b,cross;
	for(int i=0;i<4;i++){
	    a=new vector(lines[(i+1)%lines.length].getX1()-lines[i].getX1(),
			 lines[(i+1)%lines.length].getY1()-lines[i].getY1(),
			 lines[(i+1)%lines.length].getZ1()-lines[i].getZ1());
	    b=new vector(lines[i].getX1()-lines[(i-1+4)%lines.length].getX1(),
			 lines[i].getY1()-lines[(i-1+4)%lines.length].getY1(),
			 lines[i].getZ1()-lines[(i-1+4)%lines.length].getZ1());
	    vertexNormals[i]=a.cross(a,b);
	    vertexNormals[i].normalize();
	    d.println("yo, vertex normals\n"+vertexNormals[i]);
	}
    }

    public ArrayList scanline()
    {
	setInt();
	ArrayList result=new ArrayList();
	if(box)
	    result=scanlineBox();
	else
	    result=scanlineConv();
	return result;
    }

    public ArrayList shade(light l, Color ambient)
    {
	ArrayList result=new ArrayList();
	if(box)
	    result=shadeBox(l,ambient);
	else
	    result=shadeConv(l,ambient);
	return result;
    }

    protected ArrayList shadeConv(light l,Color ambient)
    {
	ArrayList result=new ArrayList();
	Color diffuse;
       	

	return result;
    }

    protected ArrayList shadeBox(light l,Color ambient)
    {
	ArrayList result=new ArrayList();
	Color diffuse,specular;
	double y,xl,xr,z;
	int min1,min2,max1,max2;
	
	min1=0;
	min2=0;
	max1=0;
	max2=0;
	
	for(int i=0; i<lines.length; i++){
            if(lines[(i+1)%lines.length].getY1()<lines[min1].getY1())
                min1=(i+1)%lines.length;
            if(lines[(i+1)%lines.length].getY1()>lines[max1].getY1())
                max1=(i+1)%lines.length;
        }
        if(lines[(min1+1)%lines.length].getY1()==lines[min1].getY1())
            min2=(min1+1)%lines.length;
        else if(lines[(min1-1+lines.length)%lines.length].getY1()==
                lines[min1].getY1())
            min2=(min1-1+lines.length)%lines.length;
	
	if(lines[(max1+1)%lines.length].getY1()==lines[max1].getY1())
            max2=(max1+1)%lines.length;
        else if(lines[(max1-1+lines.length)%lines.length].getY1()==
                lines[max1].getY1())
            max2=(max1-1+lines.length)%lines.length;
	
        xl=lines[min1].getX1();
        xr=lines[min2].getX1();
	z=lines[min1].getZ1();
        for(y=lines[min1].getY1();y<lines[max1].getY1();y++){
            matrix m=new matrix(xl,y,z,xr,y,z);
	    m.setColor(Color.red);
            m.setScanned(true);
            result.add((Object)m);
        }
	return result;
    }

    protected ArrayList scanlineConv()
    {
	int left,right,min,max;
	double xl,xr,dxr,dxl,dy,y;
	double zr,zl,dzr,dzl;
	ArrayList result=new ArrayList();
	boolean r;
	
	d.println("VISIBLE: "+visible);
	
	r=true;
	min=findLowest();
	max=findHighest();

	if(lines[(min+1)%numsides].getX1()<
	   lines[(min-1+numsides)%numsides].getX1()){
	    left=(min+1)%numsides;
	    right=(min-1+numsides)%numsides;
	}
	else{
	    left=(min-1+numsides)%numsides;
	    right=(min+1)%numsides;
	}
	if(max==left)
	    max=(max+1)%numsides;
	
	right=checkright(min,max,left,right);
	left=checkleft(min,max,left,right);
	min=checkmin(min,max,left,right);
	
	if(max !=(min+2)%numsides){
	    if((min+2)%numsides==right){
		int temp=right;
		right=max;
		max=temp;
	    }
	    else{
		int temp=left;
		left=max;
		max=temp;
	    }
	}
	
	if(lines[min].getY1()>lines[max].getY1()){
	    int temp=min;
	    min=max;
	    max=temp;
	}

	dy=1;
	xl=lines[min].getX1();
	xr=lines[min].getX1();
	zl=lines[min].getZ1();
	zr=lines[min].getZ1();

	if((lines[left].getX1()==lines[min].getX1()) &&
	   (lines[left].getY1()==lines[min].getY1()))
	    dxl=0;
	else
	    dxl=((lines[left].getX1()-lines[min].getX1())/
		 (lines[left].getY1()-lines[min].getY1()));
	
	if((lines[right].getX1()==lines[min].getX1()) &&
	   (lines[right].getY1()==lines[min].getY1()))
	    dxr=0;
	else
	    dxr=((lines[right].getX1()-lines[min].getX1())/
		 (lines[right].getY1()-lines[min].getY1()));
	
	dzl=((lines[left].getZ1()-lines[min].getZ1())/
	    (lines[left].getY1()-lines[min].getZ1()));
	dzr=((lines[right].getZ1()-lines[min].getZ1())/
	    (lines[right].getY1()-lines[min].getY1()));

	if(dxr==Double.POSITIVE_INFINITY ||dxr==Double.NEGATIVE_INFINITY
	   || dxr==Double.NaN){
	    dxr=((lines[max].getX1()-lines[right].getX1())/
		(lines[max].getY1()-lines[right].getY1()));
	    xr=lines[right].getX1();
	    zr=lines[right].getZ1();
	}
	if(dxl==Double.POSITIVE_INFINITY || dxl==Double.NEGATIVE_INFINITY 
	   || dxl==Double.NaN){
	    dxl=0;
	    xl=lines[left].getX1();
	    zl=lines[left].getX1();
	    d.println("egegergeg");
	}
	d.println("Min: "+lines[min]+min+"\nLeft: "+lines[left]+left+"\nMax: "+lines[max]+max+"\nRight: "+lines[right]+right);

	d.println("DXL: "+dxl+"\nDXR "+dxr);
	d.println("XL "+xl+"\nXR: "+xr);
	d.println("Y1: "+(int)lines[min].getY1()+"\nY2: "+(int)lines[max].getY1());
	for(y=lines[min].getY1()+1;y<=(int)lines[max].getY1(); y++){
	    /*	    if((y==lines[min].getY1() &&
		(lines[min].getY1()!=lines[right].getY1())&&
		(lines[min].getY1()!=lines[left].getY1()))
		{
		    System.out.println("GENGENGENGEN");
		}
		else{*/
	    matrix m=new matrix(xl,y,zl,xr,y,zr);
	    m.setScanned(true);
	    m.setColor(Color.red);
	    result.add((Object) m);
	    xl+=dxl;
	    xr+=dxr;
	    zl+=dzl;
	    zr+=dzr;
	    
	    d.println("Y "+y+"\nDXR: "+dxr+"\nDXL: "+dxl+"\nXL "+xl+"\nXR "+xr+"\n");
	    if(y>=lines[left].getY1()){
		left=(left+1)%numsides;
		if(left==min)
		    left=max;
		dxl=((xl-lines[left].getX1())/(y-lines[left].getY1()));
		
		if(dxl==Double.POSITIVE_INFINITY || 
		   dxl==Double.NEGATIVE_INFINITY || dxl==Double.NaN){
		    dxl=0;
		    d.println("Exception left "+left);
		}
		dzl=(zl-lines[left].getZ1())/(y-lines[left].getY1());
		d.println("Change left");
	    }
	    if(y>=lines[right].getY1()){
		right=max;
		r=false;
		dxr=((xr-lines[right].getX1())/(y-lines[right].getY1()));
		if(dxr==Double.POSITIVE_INFINITY ||
		   dxr==Double.NEGATIVE_INFINITY || dxr==Double.NaN){
		    dxr=((lines[max].getX1()-lines[right].getX1())/
			 (lines[max].getY1()-lines[right].getY1()));
		    dxr=0;
		    d.println("Exception right");
		}
		dzr=(zr-lines[right].getZ1())/(y-lines[right].getY1());
		d.println("Change right "+right);
	    }
	    //}
	}    
    	return result;
    }

    public ArrayList scanlineBox()
    {
	double y,xl,xr,z;
	int min1,min2,max1,max2;
	ArrayList result=new ArrayList();
	
	min1=0;
	min2=0;
	max1=0;
	max2=0;
	
	for(int i=0; i<lines.length; i++){
            if(lines[(i+1)%lines.length].getY1()<lines[min1].getY1())
                min1=(i+1)%lines.length;
            if(lines[(i+1)%lines.length].getY1()>lines[max1].getY1())
                max1=(i+1)%lines.length;
        }
        if(lines[(min1+1)%lines.length].getY1()==lines[min1].getY1())
            min2=(min1+1)%lines.length;
        else if(lines[(min1-1+lines.length)%lines.length].getY1()==
                lines[min1].getY1())
            min2=(min1-1+lines.length)%lines.length;
	
	if(lines[(max1+1)%lines.length].getY1()==lines[max1].getY1())
            max2=(max1+1)%lines.length;
        else if(lines[(max1-1+lines.length)%lines.length].getY1()==
                lines[max1].getY1())
            max2=(max1-1+lines.length)%lines.length;
	
        xl=lines[min1].getX1();
        xr=lines[min2].getX1();
		z=lines[min1].getZ1();
        for(y=lines[min1].getY1();y<lines[max1].getY1();y++){
            matrix m=new matrix(xl,y,z,xr,y,z);
	    m.setColor(Color.red);
            m.setScanned(true);
            result.add((Object)m);
        }
        return result;
    }
    
    public int findLowest()
    {
	int min=0;
	for(int i=0; i<numsides; i++)
	    if(lines[(i+1)%numsides].getY1()<lines[min].getY1())
		min=(i+1)%numsides;
	return min;
    }

    public int findHighest()
    {
	int max=0;
	for(int i=0; i<numsides; i++)
	    if(lines[i].getY1()>lines[max].getY1())
		max=i;
	return max;
    }
   
    private int checkright(int min,int max, int left, int right)
    {
	if(right==max || right==left || right==min)
	    right=6-(left+max+min);
	return right;
    }
	
    private int checkleft(int min, int max, int left, int right)
    {
	if(left==max || left==min)
	    left=6-(right+max+min);
	return left;
    }

    private int checkmin(int min,int max, int left,int right)
    {
	if(min==max)
	    min=6-(max+left+right);
	return min;
    }
    private int round(double d)
    {
	double temp=d-(int)d;
	if(temp>=0.5)
	    d++;
	return (int)d;
    }

    public ArrayList linear()
    {return new ArrayList();}
    public void setBox(boolean b)
    {box=b;}
    
    public boolean getVisible()
    {return visible;}    
    public vector getNormal()
    {return normal;}
    public boolean getBox()
    {return box;}
    public vector[] getVertexNormals()
    {return vertexNormals;}
    public vector getVertexNormal(int i)
    {return vertexNormals[i];}
}
