import java.awt.*;
import java.lang.*;
import java.util.*;

public class raytrace
{
    private point eye;
    private size s;
    private shape[] shapes=new shape[5];
    private int sindex;
    private light l;
    private double t0,t1;
    private Color ambient;
    private debug d=new debug(true);

    public raytrace()
    {
	eye=new point(0,0,-100);
	s=new size();
	sindex=0;
	ambient=new Color(10,10,10);
    }

    public raytrace(point p)
    {
	eye=p;
	s=new size();
	sindex=0;
	ambient=new Color(10,10,10);
    }

    public ArrayList trace()
    {
	ArrayList result=new ArrayList();
	for(int i=0; i<shapes.length; i++)
	    if(shapes[0].getName().equals("Sphere"))
		result=sphereTrace((sphereShape) shapes[0]);
	return result;
    }
    
    public ArrayList sphereTrace(sphereShape s)
    {
	d.println("START TRACE");       
	ArrayList result=new ArrayList();
	lighting lighting=new lighting();
	for(int x=0; x<this.s.getX(); x++)
	    for(int y=0; y<this.s.getY(); y++){
		vector rd=new vector(x-eye.getX(),
				     y-eye.getY(),
				     this.s.getZ()-eye.getZ());
		rd.normalize();
		
		/*****Sphere*****/
		
		
		double b=2*(rd.getX()*(eye.getX()-s.getP1().getX())+
			    rd.getY()*(eye.getY()-s.getP1().getY())+
			    rd.getZ()*(eye.getZ()-s.getP1().getZ()));
		double c=((eye.getX()-s.getP1().getX())*(eye.getX()-s.getP1().getX())+
			  (eye.getY()-s.getP1().getY())*(eye.getY()-s.getP1().getY())+
			  (eye.getZ()-s.getP1().getZ())*(eye.getZ()-s.getP1().getZ())-
			  (s.getR1()*s.getR1()));			  
		if(discriminant(b,c)){
		    double t=0;
		    if(t0<=t1 && t0>0)
			t=t0;
		    else if(t0>=t1 && t1>0)
			t=t1;
		    else if(t0>0 && t1<=0)
			t=t0;
		    else if(t1>0 && t0<=0)
			t=t1;
		    
		    point ri=new point(eye.getX()+rd.getX()*t,
				       eye.getY()+rd.getY()*t,
				       eye.getZ()+rd.getZ()*t);
		    vector normal=new vector((ri.getX()-s.getP1().getX())/s.getR1(),
					     (ri.getY()-s.getP1().getY())/s.getR1(),
					     (ri.getY()-s.getP1().getY())/s.getR1());
		    vector view=new vector(eye.getX()-ri.getX(),
					   eye.getY()-ri.getY(),
					   eye.getZ()-ri.getZ());
		    //		    d.println(((int)ri.getX())+" "+((int)ri.getY()));
		    normal.normalize();
		    view.normalize();
		    result.add((Object) lighting.light(ri,normal,view,l,ambient));
		}
	    }	
	/*****Sphere*****/
	return result;
    }

    private boolean discriminant(double b, double c)
    {
	boolean result=false;

	if(b*b>=4*c){
	    t0=((-1)*b-Math.sqrt((b*b)-(4*c)))/2;
	    t1=((-1)*b+Math.sqrt((b*b)-(4*c)))/2;
	    result=true;
	}
	return result;
    }

    public void setLight(light l)
    {this.l=l;}
    public void setEye(point p)
    {eye=p;}
    public void setSize(size s)
    {this.s=s;}
    public void setShapes(shape[] shapes)
    {this.shapes=shapes;}
    public void setAmbient(Color c)
    {ambient=c;}
    public void add(shape S)
    {
	shapes[sindex]=S;
	sindex++;
    }
}

class size
{
    private int x, y,z;
    
    public size()
    {
	x=300;
	y=300;
	z=100;
    }

    public void setX(int x)
    {this.x=x;}
    public void setY(int y)
    {this.y=y;}
    public void setZ(int z)
    {this.z=z;}
    
    public int getX()
    {return x;}
    public int getY()
    {return y;}
    public int getZ()
    {return z;}

    public String toString()
    {
	return "X: "+x+"\tY: "+y+"\tZ: "+z;
    }

}
